<?

/**********************************************************/
/*  This script is (C) Nov 2009 by Laurent Haas F6FVY     */
/*  You can copy or use this script by naming the author  */
/*  on your website with a link to the Win-Test site      */
/**********************************************************/

/* Version history

v1.1 : July 31 2010
- $callsign variable trimmed
- File type specified in the listening link

Tnx N6TV

v1.0 : Dec 2 2009
- Initial version

*/
?>

<html>

<head>
<title>Win-Test Qso Player by F6FVY</title>
</head>

<?

// Contest data

$myCallsign = "FY5KE"; // Uppercase
$contestName = "CQWW SSB 2009";
$contestYear = "2009";
?>

<body>
<font FACE="sans-serif, Arial, Helvetica, Geneva" SIZE=4>
<p><center>Listen to your QSO with <? echo $myCallsign; ?> during the <? echo $contestName; ?> contest!
<br><br>
  
<?
if (file_exists("qsl.jpg")) { ?><img src='qsl.jpg'><br><? }
if (isset ($_POST["search"])) // Search callsign with the form
{
  $callsign = trim($_POST["search"]);
  if (isset($_GET["band"])) // Reset GET variables if the current URL have some of them 
    unset($_GET["band"]);
  if (isset($_GET["mode"]))
    unset($_GET["mode"]);
}
else if (isset ($_GET["search"])) // Direct search with the URL
  $callsign = urldecode($_GET["search"]);
?>

<font FACE="sans-serif, Arial, Helvetica, Geneva" SIZE=2><br>
<form action='' method='post'>
Enter your callsign :
<INPUT type="text" size="12" maxlength="12" name="search" value="<? if (isset($callsign)) echo $callsign; ?>" tabindex="1">
<input type="submit" value="Search">
</form>
<br>
</center>

<?
include ("mp3class.php");

// Various parameters

$dataPath = "fy5keCqwwSsb2009/";
$clipPath = "clips/";
$tsFile = "CQ-WW-SSB_2009_FINAL@FY5KE.ts.txt";

$preQsoDuration = 60; // Seconds
$postQsoDuration = 60; // Seconds

// Bands and mode(s) used

if (isset($_GET["band"])) // Searched band in the URL
  $aBands[] = $_GET["band"];
else
{
  $aBands[] = "160"; // List of the available bands for this contest file
  $aBands[] = "80";
  $aBands[] = "40";
  $aBands[] = "20";
  $aBands[] = "15";
  $aBands[] = "10";
}

if (isset($_GET["mode"])) // Searched mode in the URL
  $aModes[] = strtoupper($_GET["mode"]);
else
{
  $aModes[] = "SSB"; // List of the available modes for this contest file
}

// Delete audio clips older than 24h

$hours = 24;
$limit = time() - (60 * 60 * $hours);

if (! function_exists("glob") or glob(basename($_SERVER['PHP_SELF'])) == NULL) // Some providers disable the glob function 
{
  include ("freeGlob.php"); // Use our own glob function
  $files = freeGlob($clipPath . "*.mp3");
}
else
  $files = glob($clipPath . "*.mp3");

foreach ($files as $filename)
  if (filemtime($filename) < $limit)
    unlink($filename);

// Search in log

if (! isset($callsign) || $callsign == '') // Leave
{
  ?>
</body>
</html>
  <?
  die();
}

if (!preg_match("@[A-Za-z0-9/]{3,}@", $callsign)) // Callsign error !
{
  ?>
<p>Invalid callsign!
</body>
</html>
  <?
  die();
}

if (($callsign = strtoupper($callsign)) == $myCallsign)
{
  ?>
<p>Are your serious? ;-)
</body>
</html>
  <?
  die();
}

// Get the version of the timestamps file (reserved for future use)

$tsVersion = 100; // By default

if ($fpLog = fopen($dataPath.$tsFile, "rt"))
{
  $line = fgets($fpLog, 128);
  
  while ($line[0] == "#")
  {
    if ( (strstr($line, "# VERSION ") == $line) and (strlen($line)) > 12)
    {
      $tsVersion = (int) substr($line, 10);
      break;
    }
    $line = fgets($fpLog, 128);
  }
  
  fclose($fpLog);
}

// Search all timestamps regarding this callsign

if ($fpLog = fopen($dataPath.$tsFile, "rt"))
{
  $regExp = sprintf("@^\"%s\"@", $callsign);

  while (!feof($fpLog)) // Extract lines in the $log array
  {
    $line = fgets($fpLog, 128);
    if (preg_match($regExp, $line))
      $log[] = $line; // Append the line to the $log array
  }

  fclose($fpLog);
}

if (! isset($log))
  print("<p>No QSO found...");
else
{
  if ($tsVersion > 100) // This version of wtQsoPlayer only process version 100
    print("<p>This version of timestamps file is currently not supported");
  else
  {
  // Browse $log lines, and search a QSO for each band and mode

    foreach ($aBands as $i => $band)
      foreach ($aModes as $j => $mode)
      {
        $regExp = sprintf("@^\"%s\" \"%s\" \"%s\" \".*\" \"(.*)\" ([\-0-9]+)@", $callsign, $band, $mode);
        $found = 0;
        $dupe = 0;
        foreach ($log as $k => $logLine)
        {
          if (preg_match($regExp, $logLine, $matches) > 0)
          {
            if ($matches[1] == "" or !file_exists($dataPath . $matches[1]) or ($matches[2] < 0))
              printf("<p>%sm %s : QSO found but no audio available", $band, $mode);
            else // Extract clip
            {
              if (! isset($mp3Files[$matches[1]]))
                $mp3Files[$matches[1]] = new mp3($dataPath . $matches[1], $myCallsign, $contestName, $contestYear);
  
              if ($dupe)
                $clipName = sprintf("%s%s_%s_%s_%d.mp3", $clipPath, str_replace("/", "_", $callsign), $band, $mode, $dupe);
              else
                $clipName = sprintf("%s%s_%s_%s.mp3", $clipPath, str_replace("/", "_", $callsign), $band, $mode);
  
              $title = sprintf("%s - %s (%sm %s)", $callsign, $contestName, $band, $mode);
              $mp3Files[$matches[1]]->extract($matches[2], $preQsoDuration, $postQsoDuration, $clipName, $title);
              printf("<p>%sm %s %s : <a type='audio/mpeg' href='%s'>Listen</a>", $band, $mode, ($dupe ? "(Dupe)" : ""),$clipName);
              $dupe++;
            }
            $found = 1;
          }
        }
  
        if ($found == 0)
          printf("<p>%sm %s : No QSO found", $band, $mode);
      }
  }
}

printf("<br><br><hr><p align='right'><i>Search and audio extraction processed by wtQsoPlayer - (C) Laurent Haas F6FVY - Nov 2009<br>");
printf("A companion program of the <a href='http://www.win-test.com'>Win-Test contest logger</a></i>");

?>
</body>
</html>
